<template>
  <v-data-table
    :headers="headers"
    :loading="loading"
    :items="orders"
    :page="page"
    :items-per-page="pageSize"
    :server-items-length="total"
    class="elevation-1"
  >
    <template #top>
      <v-row no-gutters>
        <v-col cols="9">
          <v-text-field
            v-model="search"
            label="Buscar por cliente"
            class="mx-2"
          />
        </v-col>
        <v-col cols="3">
          <v-select
            v-model="stateSelected"
            :items="OrderStatus"
            class="mx-2"
          />
        </v-col>
      </v-row>
    </template>
    <template #item.id="{ item }">
      {{ hashId(item) }}
    </template>
    <template #item.client="{ item }">
      {{ item.client.businessName }}
    </template>
    <template #item.units="{ item }">
      ({{ item.storedUnits }} / {{ item.toSendUnits }})
    </template>
  </v-data-table>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { errorOptions } from '~/helpers/toast';
import { hashId } from '~/helpers/format/ids';
import OrderStatus, { READY } from '~/services/sync/order-status';

export default {
  name: 'OrdersTable',
  data: () => ({
    OrderStatus,
    stateSelected: READY,
    loading: false,
    search: '',
    headers: [
      { text: 'Nª', sortable: false, value: 'id', align: 'start' },
      { text: 'Cliente', sortable: false, value: 'client', align: 'start' },
      { text: 'Unidades completadas (pallets)', sortable: false, value: 'units', align: 'center' },
    ],
  }),
  computed: {
    ...mapState({
      orders: state => state.sync.orders.orders,
      page: state => state.sync.orders.pageInfo.page,
      pageSize: state => state.sync.orders.pageInfo.pageSize,
      total: state => state.sync.orders.pageInfo.total,
    }),
  },
  watch: {
    stateSelected() {
      this.getOrdersData();
    },
    search() {
      this.getOrdersData();
    },
  },
  async mounted() {
    await this.getOrdersData();
  },
  methods: {
    hashId,
    ...mapActions({
      getOrders: 'sync/orders/getOrders',
    }),
    async getOrdersData() {
      this.loading = true;
      try {
        await this.getOrders({ search: this.search, state: this.stateSelected });
      } catch (e) {
        this.$toast.error('No se pudo obtener los pedidos de los clientes', errorOptions);
      }
      this.loading = false;
    },
  },
};
</script>
